module doodle.dia.page_layer;

public {
    import doodle.dia.icanvas;
}

private {
    import doodle.cairo.routines;
}

class PageLayer : Layer, Page {
    this(in string name) {
        super(name);
        mPageGeometry = Rectangle(Point.DEFAULT, Vector(210.0, 297.0));
        //mPageGeometry = Rectangle(Point.DEFAULT, Vector(100.0, 100.0));
    }

    // Layer overrides:

    override Rectangle bounds() const {
        return mPageGeometry;
    }

    override void draw(in Viewport viewport,
                       in Rectangle pixel_damage, scope Context pixel_cr,
                       in Rectangle model_damage, scope Context model_cr) const {
        // Make the paper white, with a border

        model_cr.save; {
            model_cr.setSourceRgba(1.0, 1.0, 1.0, 1.0);
            rectangle(model_cr, mPageGeometry);
            model_cr.fill;
        } model_cr.restore;

        model_cr.save; {
            model_cr.setSourceRgba(0.0, 0.0, 0.0, 1.0);
            rectangle(model_cr, mPageGeometry);
            model_cr.stroke;
        } model_cr.restore;
    }

    // Page overrides:

    private {
        Rectangle mPageGeometry;
    }
}
